with Ada.Unchecked_Conversion;
with Interfaces.C;
with Interfaces.C.Strings;
with ma_extra;
with System;
with Win32.Wingdi;
with Convert,reversi;

package body Generic_Pkg is

  use Win32;
  use type System.Address;
  function LPCSTR_TO_LPARAM is new Ada.Unchecked_Conversion (Win32.LPCSTR,
                                                       Win32.LPARAM); 
  function UC is new Ada.Unchecked_Conversion
                             (System.Address,Win32.LPCSTR);
  function CP(C_Str : Win32.CHAR_Array) return Win32.LPCSTR is
      
  begin
      return UC(C_Str(C_Str'First)'Address);
  end CP;


  Help_Ptr    : Win32.LPCSTR := CP("reversi.hlp" & Nul);
  No_Help_Ptr : Win32.LPCSTR := CP("Unable to activate help" & Nul);
  
  zacat: Win32.LPCSTR := CP("Zatenk" & Nul);
  pokroc: Win32.LPCSTR := CP("Pokroil" & Nul);
  vicemistr: Win32.LPCSTR := CP("Vicemistr" & Nul);
  mistr: Win32.LPCSTR := CP("Mistr" & Nul);
  
   
  -- Used in DrawPaintProc
  ps    : aliased Win32.WinUser.PAINTSTRUCT;

--  FUNCTION: CenterWindow (HWND, HWND)
--
--  PURPOSE:  Center one window over another
--
--  COMMENTS:
--
--  Dialog boxes take on the screen position that they were designed at,
--  which is not always appropriate. Centering the dialog over a particular
--  window usually results in a better position.
--function RedrawMainWindow(HWND:Windef.HWND, MESSAGE, WPARAM, LPARAM);
function CenterWindow(hWndChild, hWndParent : Windef.HWND) return
                                              Win32.BOOL is

  rChild_Ptr  : Windef.LPRECT;
  rParent_Ptr : Windef.LPRECT;

  wChild  : Win32.LONG;
  hChild  : Win32.LONG;
  wParent : Win32.LONG;
  hParent : Win32.LONG;
  wScreen : Win32.LONG;
  hScreen : Win32.LONG;
  xNew    : Win32.LONG;
  yNew    : Win32.LONG;
  HDC     : Windef.HDC;

  use type Interfaces.C.Long;	-- to get '-'
  use type Win32.UINT;

begin
  --  // Get the Height and Width of the child window
  rChild_Ptr := rChild'Access;
  bResult    := Winuser.GetWindowRect(hWndChild, rChild_Ptr);
  wChild     := rChild.RIGHT - rChild.LEFT;
  hChild     := rChild.BOTTOM - rChild.TOP;

  -- // Get the Height and Width of the parent window
  rParent_Ptr := rParent'Access;
  bResult     := Winuser.GetWindowRect(hWndParent, rParent_Ptr);
  wParent     := rParent.RIGHT - rParent.LEFT;
  hParent     := rParent.BOTTOM - rParent.TOP;

  -- // Get the display limits
  HDC     := Winuser.GetDC(hWndChild);
  wScreen := Win32.LONG(Wingdi.GetDeviceCaps(HDC, Wingdi.HORZRES));
  hScreen := Win32.LONG(Wingdi.GetDeviceCaps(HDC, Wingdi.VERTRES));
  iResult := Winuser.ReleaseDC(hWndChild, HDC);

  -- // Calculate new X position, then adjust for screen
  xNew := rParent.LEFT + ((wParent - wChild) / 2);
  if xNew < 0 then
    xNew := 0;
  elsif (xNew + wChild) > wScreen then
    xNew := wScreen - wChild;
  end if;

  -- // Calculate new Y position, then adjust for screen
  yNew := rParent.TOP + ((hParent - hChild) / 2);
  if yNew < 0 then
    yNew := 0;
  elsif (yNew + hChild) > hScreen then
    yNew := hScreen - hChild;
  end if;

  -- // Set it, and return
  return Winuser.SetWindowPos(hWndChild, 
                              System.Null_Address, 
                              Win32.INT(xNew), Win32.INT(yNew), 0, 0,
                              Winuser.SWP_NOSIZE or Winuser.SWP_NOZORDER);
end CenterWindow;

procedure DrawPaintProc (hWnd_p : Win32.WinDef.HWND) is
    use type Win32.INT;
    hDC_p : Win32.WinDef.HDC;
  i,n: Win32.INT;
  begin
  hDC_p := Win32.WinUser.BeginPaint (hWnd_p, ps'Access);
  if hDC_p /= System.Null_Address then 
     bResult:=Win32.WinGdi.Rectangle(hDC_p,0,0,320,320);
     
     for i in 1..7 loop
     bResult:=Win32.WinGdi.Rectangle(hDC_p,Win32.INT(i*40),0,Win32.INT(i*40+1),320);
     bResult:=Win32.WinGdi.Rectangle(hDC_p,0,Win32.INT(i*40),320,Win32.INT(i*40+1));
         
     end loop;     
     for i in 1..8 loop
     for n in 1..8 loop    
      if Reversi.board(i,n)/=0 then bResult:=Reversi.DrawStone(hDC_p,i,n,reversi.board(i,n));
      end if;    
     end loop;
     end loop;
     bResult := Win32.WinUser.EndPaint (hWnd_p, ps'Access);
  end if;
end DrawPaintProc;


function NewGame(hDlg    : Win32.Windef.HWND;
               MESSAGE : Win32.UINT;
               WPARAM  : Win32.WPARAM;
               LPARAM  : Win32.LPARAM) return Win32.BOOL is

  use type Interfaces.C.UNSIGNED_SHORT;
  use type Win32.INT;

  colorref:Win32.Windef.COLORREF;
hDC_p : Win32.WinDef.HDC;
hWND,item: Win32.Windef.HWND;  
cerveny   : Win32.WinDef.HBRUSH;
hBrush_p   : Win32.WinDef.HGDIOBJ;
cmdId         : Win32.WORD;
  Dummy         : Win32.BOOL;
  re         : Win32.INT;
  i,n:integer;
result:Win32.LRESULT;
begin
    case MESSAGE is

  when Win32.Winuser.WM_INITDIALOG =>
  bResult:= win32.winuser.CheckRadioButton(hDlg,ma_extra.IDC_RADIO1,ma_extra.IDC_RADIO2,ma_extra.IDC_RADIO1);
  bResult:= win32.winuser.CheckRadioButton(hDlg,ma_extra.IDC_RADIO3,ma_extra.IDC_RADIO4,ma_extra.IDC_RADIO4);
  bResult:= win32.winuser.CheckRadioButton(hDlg,ma_extra.IDC_RADIO3,ma_extra.IDC_RADIO4,ma_extra.IDC_RADIO4);
  item:=Win32.winuser.GetDlgItem(hDlg,  ma_extra.IDC_COMBO1);
  result:=win32.winuser.SendMessage(item,winuser.CB_ADDSTRING,0,LPCSTR_TO_LPARAM(zacat));
  result:=win32.winuser.SendMessage(item,winuser.CB_ADDSTRING,0,LPCSTR_TO_LPARAM(pokroc));
  --result:=win32.winuser.SendMessage(item,winuser.CB_ADDSTRING,0,LPCSTR_TO_LPARAM(vicemistr));
  result:=win32.winuser.SendMessage(item,winuser.CB_ADDSTRING,0,LPCSTR_TO_LPARAM(mistr));
  result:=win32.winuser.SendMessage(item,winuser.CB_SETCURSEL,0,0);
  
  item:=Win32.winuser.GetDlgItem(hDlg,  ma_extra.IDC_COMBO2);
  result:=win32.winuser.SendMessage(item,winuser.CB_ADDSTRING,0,LPCSTR_TO_LPARAM(zacat));
  result:=win32.winuser.SendMessage(item,winuser.CB_ADDSTRING,0,LPCSTR_TO_LPARAM(pokroc));
  --result:=win32.winuser.SendMessage(item,winuser.CB_ADDSTRING,0,LPCSTR_TO_LPARAM(vicemistr));
  result:=win32.winuser.SendMessage(item,winuser.CB_ADDSTRING,0,LPCSTR_TO_LPARAM(mistr));
  result:=win32.winuser.SendMessage(item,winuser.CB_SETCURSEL,1,0);
  --bResult:=win32.winuser.SendMessage(item,winuser.CB_ADDSTRING,0,UC(pokroc));
    --cerveny:= Win32.WinGdi.CreateSolidBrush (Win32.WinGdi.RGB (255,0,0));
         -- Center the dialog over the application window
      bResult := CenterWindow(hDlg, Win32.Winuser.GetWindow
                                           (hDlg, Win32.Winuser.GW_OWNER));
   return Win32.TRUE;
      -- create a font to use
       
  when Winuser.WM_COMMAND =>
      cmdId := WinDef.LOWORD(Win32.DWORD(WPARAM));
      if ((cmdId = Winuser.IDOK) or (cmdId = Winuser.IDCANCEL)) then
        if (cmdID= Winuser.IDOK) then 
         
         if UINT_to_integer(win32.winuser.IsDlgButtonChecked(hDlg,ma_extra.IDC_RADIO1))=1 then
             reversi.pl1:=1; else reversi.pl1:=2; end if;
         if UINT_to_integer(win32.winuser.IsDlgButtonChecked(hDlg,ma_extra.IDC_RADIO3))=1 then
             reversi.pl2:=1; else reversi.pl2:=2; end if;
         ---  nastav hloubku rekurze u pocitacu;
           item:=Win32.winuser.GetDlgItem(hDlg,  ma_extra.IDC_COMBO1);
           reversi.diff1:=Convert.LRESULT_TO_Integer(win32.winuser.SendMessage(item,winuser.CB_GETCURSEL,0,0))*2+1;
           item:=Win32.winuser.GetDlgItem(hDlg,  ma_extra.IDC_COMBO2);
           reversi.diff2:=Convert.LRESULT_TO_Integer(win32.winuser.SendMessage(item,winuser.CB_GETCURSEL,0,0))*2+1;
             
          -- reversi.diff1:=1;
          -- reversi.diff2:=5;    
  
  
  
             reversi.InitControlBoard;
             reversi.onturn:=1;
             reversi.playing:=true;
             for i in 0..9 loop
              for n in 0..9 loop    
               reversi.board(i,n):=0;
               if i=0 or i=9 or n=0 or n=9 then reversi.board(i,n):=3;   end if;
               end loop;
              end loop;
             reversi.board(4,4):=1;reversi.board(5,5):=1;
             reversi.board(4,5):=2;reversi.board(5,4):=2;
            
            bresult:=win32.winuser.InvalidateRgn(win32.winuser.GetParent(hDLG),win32.wingdi.CreateRectRgn(0,0,326,365),
            win32.FALSE);
            --bresult:=win32.winuser.Updatewindow(win32.winuser.GetParent(hDLG));
            bresult:=win32.winuser.PostMessage(win32.winuser.GetParent(hDLG),winuser.WM_PAINT,0,0);
            
            bresult:=win32.winuser.PostMessage(win32.winuser.GetParent(hDLG),winuser.WM_COMMAND
                 ,ma_extra.IDM_PLAYGAME,0);
             
         end if;
          Dummy := Winuser.EndDialog (hDlg, 1);

          return Win32.TRUE;
      end if;
      
--  when Winuser.WM_CTLCOLORSTATIC =>
  -- hDC_p:= WPARAM_TO_HDC(WPARAM);
   --hWND:=LPARAM_TO_HWND(LPARAM);   
   --if hWND=Win32.winuser.GetDlgItem(hDlg,  ma_extra.IDC_STATIC1) then
       
    --colorref:=win32.wingdi.SetTextColor(hDC_p,win32.wingdi.RGB(255,255,255));   
    --colorref:=win32.wingdi.SetBkColor(hDC_p,win32.wingdi.RGB(255,0,0));   
    --hBrush_p := Win32.WinGdi.SelectObject (hDC_p, Win32.Windef.HGDIOBJ (cerveny));
    --re:=win32.winuser.MessageBox(hDlg,CP("kuk" & Nul),CP("nic" & Nul),0);
    --return win32.TRUE;
   --end if;
   --return win32.FALSE;
    
  when others =>
      return Win32.FALSE;

  end case;
  return Win32.FALSE;

end NewGame;


function About(hDlg    : Win32.Windef.HWND;
               MESSAGE : Win32.UINT;
               WPARAM  : Win32.WPARAM;
               LPARAM  : Win32.LPARAM) return Win32.BOOL is

  use type Interfaces.C.UNSIGNED_SHORT;

  cmdId         : Win32.WORD;
  Dummy         : Win32.BOOL;

begin
  case MESSAGE is

  when Win32.Winuser.WM_INITDIALOG =>
      -- Center the dialog over the application window
      bResult := CenterWindow(hDlg, Win32.Winuser.GetWindow
                                           (hDlg, Win32.Winuser.GW_OWNER));
      return Win32.TRUE;
      -- create a font to use
      
  when Winuser.WM_COMMAND =>
      cmdId := WinDef.LOWORD(Win32.DWORD(WPARAM));
      if ((cmdId = Winuser.IDOK) or (cmdId = Winuser.IDCANCEL)) then
        Dummy := Winuser.EndDialog (hDlg, 1);
        return Win32.TRUE;
      end if;

  when others =>
      return Win32.FALSE;

  end case;
  return Win32.FALSE;

end About;



--  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
--
--  PURPOSE:  Processes messages
--
--  MESSAGES:
--
--  WM_COMMAND    - application menu (About dialog box)
--  WM_DESTROY    - destroy window
--
--  COMMENTS:
--
--  To process the IDM_ABOUT message, call MakeProcInstance() to get the
--  current instance address of the About() function.  Then call Dialog
--  box which will create the box according to the information in your
--  generic.rc file and turn control over to the About() function.  When
--  it returns, free the intance address.
--
function WndProc (hwnd    : Win32.Windef.HWND;
                  message : Win32.UINT;
                  wParam  : Win32.WPARAM;
                  lParam  : Win32.LPARAM) return Win32.LRESULT is
                  
  use type Interfaces.C.INT;
  use type Win32.UINT;
  hDC_p : Win32.WinDef.HDC;
  xmpos,ympos:win32.WORD;
  xpos,ypos:integer;
  pl1points,pl2points:integer;
  wmID: Win32.WORD;
  wmEvent: Win32.WORD;
  lprc: win32.windef.LPRECT;
  begin
  case message is 
    when Winuser.WM_COMMAND =>
      wmID     := WinDef.LOWORD(Win32.DWORD(WPARAM));
      wmEvent  := WinDef.HIWORD(Win32.DWORD(WPARAM));

      case wmID is

        when ma_extra.IDM_ABOUT =>
          iResult := Winuser.DialogBox(HINST,
                                       Win32.LPCSTR(WinUser.MAKEINTRESOURCE(
                                           ma_extra.IDD_ABOUTBOX)),
                                       HWND, About'Access);
        when ma_extra.IDM_NEW =>
           -- iresult:=winuser.IDYES;
           -- if reversi.playing=true then
           --   iresult:=win32.winuser.MessageBox(hwnd,CP("Chcete ukonit hru?" & Nul),CP("Otzka" & Nul),
           --   Winuser.MB_YESNOCANCEL);  
           --end if;
           --if iresult =winuser.IDYES then
           iResult := Winuser.DialogBox(HINST,
                                       Win32.LPCSTR(WinUser.MAKEINTRESOURCE(
                                           ma_extra.IDD_NEWGAME)),
                                       HWND, NewGame'Access);
           --end if;
        when ma_extra.IDM_EXIT =>
          bResult := Winuser.DestroyWindow(HWND);

        when ma_extra.IDM_HELPCONTENTS =>
          bResult := Winuser.WinHelp(HWND,
                                     Help_Ptr,
                                     Winuser.HELP_CONTENTS,
                                     0);
          if bResult = Win32.FALSE then
            iResult := Winuser.MessageBox(Winuser.GetFocus,
                                          No_Help_Ptr,
                                          SZAPPNAME,
                                          (Winuser.MB_SYSTEMMODAL or 
                                           Winuser.MB_OK or
                                            Winuser.MB_ICONHAND));
          end if;

        when ma_extra.IDM_HELPSEARCH =>
          bResult := Winuser.WinHelp(HWND,
                                     Help_Ptr,
                                     Winuser.HELP_PARTIALKEY,
                                     LPCSTR_To_DWORD(CP("CONTENTS" & Nul)));
          if bResult = Win32.FALSE then
            iResult := Winuser.MessageBox (Winuser.GetFocus,
                                           No_Help_Ptr,
                                           SZAPPNAME,
                                           (Winuser.MB_SYSTEMMODAL or
                                            Winuser.MB_OK or
                                            Winuser.MB_ICONHAND));
          end if;
        when ma_extra.IDM_ENDOFGAME =>
            pl1points:=reversi.GetNumberOfPoints(1);
            pl2points:=reversi.GetNumberOfPoints(2);
            if pl1points=pl2points  then
              iresult:=win32.winuser.MessageBox(hwnd,CP("Remza" & Nul),CP("Konec Hry" & Nul),0);  
             elsif pl1points>pl2points  then
              iresult:=win32.winuser.MessageBox(hwnd,CP("Vyhrv hr 1 (erven)" & Nul),CP("Konec Hry" & Nul),0);  
             else iresult:=win32.winuser.MessageBox(hwnd,CP("Vyhrv hr 2 (modr)" & Nul),CP("Konec Hry" & Nul),0);  
            end if;
            
        when ma_extra.IDM_PLAYGAME =>
          if reversi.playing=true then
           if (reversi.onturn=1 and reversi.pl1=2) or
              (reversi.onturn=2 and reversi.pl2=2) then -- hraje pocitac 
             
              --iresult:=win32.winuser.MessageBox(hwnd,CP("Budu hrat" & Nul),CP("KUK" & Nul),0);  
             reversi.ComputerMove(hwnd);
              
             --bresult:=win32.winuser.InvalidateRgn(hwnd,win32.wingdi.CreateRectRgn(0,0,326,365),
             --win32.FALSE);
             --bresult:=win32.winuser.Updatewindow(hwnd);
           
             reversi.ChangeTurn;
             if reversi.onturn=3 or reversi.onturn=0 then       -- 3 ..pole je komplet zaplneno
                reversi.playing:=false;                       -- 0 .. hra je zablokovana
                bresult:=win32.winuser.PostMessage(hwnd,winuser.WM_COMMAND,ma_extra.IDM_ENDOFGAME,0);
              else
               if (reversi.onturn=1 and reversi.pl1=2) or (reversi.onturn=2 and reversi.pl2=2) then
                  -- vygeneruj zpravu pro pocitac
                  bresult:=win32.winuser.PostMessage(hwnd,winuser.WM_COMMAND,ma_extra.IDM_PLAYGAME,0);
               end if;
             end if;        
                  
            --iresult:=win32.winuser.MessageBox(hwnd,CP("Hraje Pota" & Nul),CP("Zprva" & Nul),0); 
            --bResult:=win32.TRUE;
           end if;
          end if;
            
        when ma_extra.IDM_HELPHELP =>
          bResult := Winuser.WinHelp(HWND,
                                     null,
                                     Winuser.HELP_HELPONHELP, 0);
          if bResult = Win32.FALSE then
            iResult := Winuser.MessageBox(Winuser.GetFocus,
                                          No_Help_Ptr,
                                          SZAPPNAME,
                                          (Winuser.MB_SYSTEMMODAL or
                                           Winuser.MB_OK or
                                           Winuser.MB_ICONHAND));
          end if;

        when others =>
          return Winuser.DefWindowProc(HWND, MESSAGE, WPARAM, LPARAM);

      end case;

    when Winuser.WM_LBUTTONDOWN =>
      if reversi.playing=true then
       if (reversi.onturn=1 and reversi.pl1=1) or       -- na tahu je hrac.
          (reversi.onturn=2 and reversi.pl2=1) then
  
        xmpos  := WinDef.LOWORD(Win32.DWORD(LPARAM));   --mouse coordinates
        ympos  := WinDef.HIWORD(Win32.DWORD(LPARAM));      
        xpos:=WORD_to_integer(xmpos)/40+1;      
        ypos:=WORD_to_integer(ympos)/40+1;               
        if reversi.IsPossible(xpos,ypos,reversi.onturn)=true then 
         --iresult:=win32.winuser.MessageBox(hwnd,CP("Chci polozit" & Nul),CP("nic" & Nul),0); 
          reversi.put(hwnd,xpos,ypos,reversi.onturn); 
            --bresult:=win32.winuser.InvalidateRgn(hwnd,win32.wingdi.CreateRectRgn(
            --WORD_to_INT(xmpos)-40,WORD_to_INT(ympos)-40,
            --WORD_to_INT(xmpos)+40,WORD_to_INT(ympos)+40),win32.FALSE);
            --bresult:=win32.winuser.UpdateWindow(hwnd);
          --bresult:=win32.winuser.InvalidateRgn(hwnd,win32.wingdi.CreateRectRgn(0,0,326,365),
          --win32.FALSE);
          --bresult:=win32.winuser.Updatewindow(hwnd);
          --iresult:=win32.winuser.MessageBox(hwnd,CP("polozil jsem " & Nul),CP("nic" & Nul),0);  
          reversi.ChangeTurn;
          if reversi.onturn=3 or reversi.onturn=0 then       -- 3 ..pole je komplet zaplneno
               reversi.playing:=false;                       -- 0 .. hra je zablokovana
               bresult:=win32.winuser.PostMessage(hwnd,winuser.WM_COMMAND,ma_extra.IDM_ENDOFGAME,0);
           else
               if (reversi.onturn=1 and reversi.pl1=2) or (reversi.onturn=2 and reversi.pl2=2) then
                -- vygeneruj zpravu pro pocitac
                bresult:=win32.winuser.PostMessage(hwnd,winuser.WM_COMMAND,ma_extra.IDM_PLAYGAME,0);
               end if;
          end if;    
        end if;            
       end if;    
      end if;  
    when Winuser.WM_DESTROY =>
    
        Winuser.PostQuitMessage(0);

    when Winuser.WM_PAINT =>  
        DrawPaintProc (HWND);
    when others =>
      return Winuser.DefWindowProc(HWND, MESSAGE, WPARAM, LPARAM);

  end case;
  return (0);

end WndProc;

begin

    SZAPPNAME := CP("Reversi"); -- the name of app


-------------------------------------------------------------------------------
--
-- THIS FILE AND ANY ASSOCIATED DOCUMENTATION IS PROVIDED "AS IS" WITHOUT 
-- WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT 
-- LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR 
-- A PARTICULAR PURPOSE.  The user assumes the entire risk as to the accuracy 
-- and the use of this file.  This file may be used only by licensees of 
-- Microsoft Corporation's WIN32 Software Development Kit in accordance with 
-- the terms of the licensee's End-User License Agreement for Microsoft 
-- Software for the WIN32 Development Kit.
--
-- Copyright (c) Intermetrics, Inc. 1995
-- Portions (c) 1985-1994 Microsoft Corporation with permission.
-- Microsoft is a registered trademark and Windows and Windows NT are 
-- trademarks of Microsoft Corporation.
--
-------------------------------------------------------------------------------

end Generic_Pkg;
